var pycore;

/**
 * @description: import python module class
 * @return {*}
 */
class PyModule {
    constructor(pModule) {
        this._pModule = pModule;
    }
    
    callSync = (func, args) => {
        let result = pycore.callSync(this._pModule, func, args);
        return result;
    }

    call = (func, args, callbackOk = null, callbackError = null) => {
        pycore.call(this._pModule, func, args, callbackOk, callbackError);
    }
}

/**
 * @description: all function
 * @return {*}
 */
let func = {
    init(config) {
        pycore = require(`./addons/${config['python_version']}/${process.platform}/${process.arch}/pycore`);
        pycore.init(config);
    },
    import(pModule){
        let pyModule = new PyModule(pModule);
        return pyModule;
    },
    runScriptSync(pyScript){
        pycore.runScriptSync(pyScript);
    },
    runScript(pyScript){
        pycore.runScript(pyScript);
    },
    release(){
        pycore.release();
    },
    about(){
        pycore.about();
    }
}

module.exports = func